"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var sequelize_1 = require("sequelize");
var Author_1 = require("./models/Author");
var Post_1 = require("./models/Post");
var Comment_1 = require("./models/Comment");
var index_1 = require("../index");
var prettyjson = require("prettyjson");
var Person_1 = require("./models/validation-only/Person");
var Book_1 = require("./models/Book");
/* tslint:disable:no-console */
/* tslint:disable:no-unused-new */
new index_1.Sequelize({
    validateOnly: true,
    modelPaths: [__dirname + '/models/validation-only']
});
var person = new Person_1.Person({
    name: 'dsfsdfdsfsdfdsff'
});
person
    .validate()
    .then(function (err) {
    console.error(err);
})
    .catch(function (err) {
    console.error(err);
});
var sequelize = new index_1.Sequelize({
    name: 'blog',
    dialect: 'mysql',
    host: 'localhost',
    username: 'root',
    password: '',
    modelPaths: [
        __dirname + '/models'
    ]
});
sequelize
    .sync({ force: true })
    .then(function () { return sequelize_1.Promise.all([
    Author_1.Author.create({ name: 'elisa', secret: '3k435kj43' }),
    Author_1.Author.create({ name: 'nelly' }),
    Author_1.Author.create({ name: 'elisa' })
]); })
    .then(function (_a) {
    var robin = _a[0], nelly = _a[1], elisa = _a[2];
    return Post_1.Post
        .create({ text: 'hey', authorId: nelly.id })
        .then(function (post) { return Comment_1.Comment.create({
        postId: post.id,
        text: 'my comment',
        authorId: robin.id
    }); })
        .then(function () {
        robin.name = 'robin';
        return sequelize_1.Promise.all([
            robin.save(),
            robin.$add('friend', nelly),
            robin.$add('friend', elisa)
        ]);
    });
})
    .then(function () {
    var post = new Post_1.Post({
        text: 'hey2',
        author: {
            name: 'jörn'
        }
    }, { include: [Author_1.Author] });
    return post.save();
})
    .then(function () { return Post_1.Post.build({ text: 'hey3' }).save(); })
    .then(function () { return Post_1.Post
    .findAll({
    attributes: ['id', 'text'],
    include: [{
            model: Comment_1.Comment,
            attributes: ['id', 'text'],
            include: [{
                    model: Author_1.Author,
                    include: [{
                            model: Author_1.Author,
                            through: {
                                attributes: []
                            }
                        }]
                }]
        }, {
            model: Author_1.Author,
            include: [{
                    model: Author_1.Author,
                    through: {
                        attributes: []
                    }
                }]
        }
    ]
})
    .then(function (posts) {
    console.log(prettyjson.renderString(JSON.stringify(posts)));
    posts.forEach(function (post) {
        console.log(post instanceof Post_1.Post);
    });
})
    .then(function () { return Author_1.Author.findAll(); })
    .then(function (authors) {
    console.log('--------------- AUTHOR DEFAULT SCOPE ----------------');
    console.log(prettyjson.renderString(JSON.stringify(authors)));
})
    .then(function () { return Author_1.Author.scope('full').findAll(); })
    .then(function (authors) {
    console.log('--------------- AUTHOR FULL SCOPE -------------------');
    console.log(prettyjson.renderString(JSON.stringify(authors)));
})
    .then(function () { return Author_1.Author.unscoped().findAll(); })
    .then(function (authors) {
    console.log('--------------- AUTHOR UN-SCOPE ---------------------');
    console.log(prettyjson.renderString(JSON.stringify(authors)));
})
    .then(function () { return Post_1.Post.scope('full').findAll(); })
    .then(function (posts) {
    console.log('--------------- POST FULL SCOPE ---------------------');
    console.log(prettyjson.renderString(JSON.stringify(posts)));
}); })
    .then(function () { return sequelize_1.Promise.all([
    Book_1.Book.create({ title: 'Sherlock Holmes' }),
    Author_1.Author.create({ name: 'Sir Arthur Conan Doyle' }),
    Author_1.Author.create({ name: 'No-Ghost' }),
]); })
    .then(function (_a) {
    var book = _a[0], authors = _a.slice(1);
    return book
        .$set('authors', authors)
        .then(function () { return Book_1.Book.scope('withAuthors').findById(book.id); })
        .then(function (_book) {
        console.log('--------------- BOOOOOOOOOOOOOOOOOK ---------------------');
        console.log(prettyjson.renderString(JSON.stringify(_book)));
    })
        .then(function () { return Book_1.Book.findById(book.id); })
        .then(function (_book) { return _book.$get('authors'); })
        .then(function (_authors) {
        console.log('--------------- BOOOKS AUTHOOOOOOOR ---------------------');
        console.log(prettyjson.renderString(JSON.stringify(_authors)));
    });
});
//# sourceMappingURL=app.js.map